<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Consultas_model extends CI_Model {



	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->driver('cache', array('adapter' => 'file', 'key_prefix' => 'ata_'));

		$this->idabogado = $this->session->userdata('consultor_idabogado');
		$this->tipousuario = $this->session->userdata('consultor_tipo_usuario');
	}

	// public function busqueda_expediente($dato){
	// 	$query=$this->db->select('lista_clientes.*')
	// 	->from('lista_clientes');
	// 	$wildcarded_hint = '%'.$dato.'%';
	// 	$this->db->where('lista_clientes.nombres LIKE',$wildcarded_hint)
	// 	->or_where('lista_clientes.apellidop LIKE',$wildcarded_hint)
	// 	->or_where('lista_clientes.apellidom LIKE',$wildcarded_hint)
	// 	->get()->result();

	// 	foreach ($query as $value) {
	// 		$resultado = $value->apellidop.''.$value->apellidom.''.$value->nombres;
	// 	}
	// 	return $resultado;

	// }

	public function lista_casos($idcliente = '', $order_by = 'por-fecha', $order_mode = 'asc', $start = 0, $limit=5,$dato)
	{
		//die('<pre>'.print_r($dato,1).'</pre>');
		$this->db->select('lista_clientes.nombres, lista_clientes.apellidop, lista_clientes.apellidom,lista_clientes.confirmacion_pago,lista_consultas.expedientelegal,lista_consultas.nombre_materia,lista_consultas.nombre_tema,lista_consultas.nombre_subtema,casos.*');
		$this->db->from('casos');

		$this->db->join('lista_clientes', 'casos.idcliente = lista_clientes.idcliente', 'left');
		
		//$this->db->join('consultas','consultas.idcaso=casos.idcaso','left');
		$this->db->join('lista_consultas','lista_consultas.idcaso = casos.idcaso','left');
		$wildcarded_hint = '%'.$dato.'%';

		if(!isset($this->tipousuario) OR is_null($this->tipousuario) OR $this->tipousuario !== 'administrador'){
			$this->db->where('casos.estado', 1);
			$this->db->where('casos.idabogado', $this->idabogado);
		}

		//echo $this->tipousuario, ", ", $this->idabogado, ", ", strlen($wildcarded_hint);
		//die();

		if (strlen($wildcarded_hint) > 2) {
			$this->db->group_start();
			$this->db->where('lista_clientes.nombres LIKE',$wildcarded_hint)
	 			->or_where('lista_clientes.apellidop LIKE',$wildcarded_hint)
	    		->or_where('lista_clientes.apellidom LIKE',$wildcarded_hint);
	    	$this->db->group_end();
		}
		
		//$this->db->where_in('lista_clientes.apellidop',$dato);
		//$this->db->where_in('lista_clientes.apellidom',$dato);
		//$this->db->where_in('casos.sinopsis',$dato);
		// $this->db->where_in('lista_consultas.expedientelegal',$dato);
		// $this->db->where_in('lista_consultas.nombre_tema',$dato);
		// $this->db->where_in('lista_consultas.nombre_materia',$dato);
		// $this->db->where_in('lista_consultas.nombre_subtema',$dato);



		if ($idcliente !== '') {
			$this->db->where('casos.idcliente', $idcliente);
		}

		//$this->db->order_by('estado', 'desc');

		if ($order_by == 'por-nombre') {
			$this->db->order_by('concat(apellidop, apellidom, nombres)', $order_mode, FALSE);
		} elseif ($order_by == 'por-fecha') {
			$this->db->order_by('fechaapertura', $order_mode);
		} 

		$this->db->limit($limit, $start);

		$query = $this->db->get();
		//die("<pre>".print_r($query->result(),1)."</pre>");

		//echo '<pre>'.print_r($this->db->last_query(), TRUE).'</pre>';
		//die();

		return $query->result();
	}

	public function lista_consultas_count()
	{
		$this->db->select('consultas.*, casos.sinopsis, lista_clientes.idcliente, lista_clientes.nombres');
		$this->db->from('consultas');
		$this->db->join('casos', 'consultas.idcaso = casos.idcaso', 'left');
		$this->db->join('lista_clientes', 'casos.idcliente = lista_clientes.idcliente', 'left');

		if(!isset($this->tipousuario) OR is_null($this->tipousuario) OR ($this->tipousuario !== 'administrador' AND $this->tipousuario !== 'ejecutor')){
			$this->db->where('casos.estado', 1);
			$this->db->where('casos.idabogado', $this->idabogado);
		}

		if($this->tipousuario == 'ejecutor'){
			$this->db->where('consultas.completada', 1);
		}

		$query = $this->db->get();

		return $query->num_rows();
	}

	public function lista_casos_count()
	{
		$this->db->select('lista_clientes.nombres, lista_clientes.apellidop, lista_clientes.apellidom, casos.*');
		$this->db->from('casos');
		$this->db->join('lista_clientes', 'casos.idcliente = lista_clientes.idcliente', 'left');

		if(!isset($this->tipousuario) OR is_null($this->tipousuario) OR $this->tipousuario !== 'administrador'){
			$this->db->where('casos.estado', 1);
			$this->db->where('casos.idabogado', $this->idabogado);
		}

		$query = $this->db->get();

		return $query->num_rows();
	}

	public function lista_consultas($start = 0, $limit=5, $order_by = 'por-fecha', $order_mode = 'asc')
	{
		// SELECT 
		//		consultas.*,
		//		casos.sinopsis,
		//		lista_clientes.idcliente,
		// 		lista_clientes.nombres
		// FROM
  		// 		ata.consultas
  		// LEFT JOIN
  		// 		ata.casos ON consultas.idcaso = casos.idcaso
  		// LEFT JOIN
  		// 		lista_clientes ON casos.idcliente = lista_clientes.idcliente;

		$this->db->select('consultas.*, casos.sinopsis, lista_clientes.idcliente, lista_clientes.nombres');
		$this->db->from('consultas');
		$this->db->join('casos', 'consultas.idcaso = casos.idcaso', 'left');
		$this->db->join('lista_clientes', 'casos.idcliente = lista_clientes.idcliente', 'left');

		if(!isset($this->tipousuario) OR is_null($this->tipousuario) OR ($this->tipousuario !== 'administrador' AND $this->tipousuario !== 'ejecutor')){
			$this->db->where('casos.estado', 1);
			$this->db->where('casos.idabogado', $this->idabogado);
		}

		if($this->tipousuario == 'ejecutor'){
			$this->db->where('consultas.completada', 1);
			$this->db->where('consultas.seguimiento', 1);
			$this->db->where('consultas.idabogadoejecutor', $this->idabogado);
		} else {
			//$this->db->where('consultas.completada', 0);
			$this->db->order_by('consultas.completada', 'desc');
		}

		if ($order_by == 'por-nombre') {
			$this->db->order_by('concat(apellidop, apellidom, nombres)', $order_mode, FALSE);
		} elseif ($order_by == 'por-fecha') {
			$this->db->order_by('fecha', $order_mode);
		} 

		$this->db->limit($limit, $start);

		$query = $this->db->get();

		return $query->result();
	}

	public function nuevo_caso($caso=array())
	{
		if($this->db->insert('casos', $caso)){
			return $this->db->insert_id();
		} else {
			return -1;
		}
	}

	public function nueva_consulta()
	{
		$idmateria=$this->input->post('materia');
		$idtema=$this->input->post('tema');
		$idsubtema=$this->input->post('subtema');
		//$expedientelegal=$this->input->post('expedientelegal');

		$materia=implode(',', $idmateria);
		$tema=implode(',', $idtema);
		$subtema=implode(',', $idsubtema);
		
		//$materia=serialize($idmateria);
		//var_dump($idmateria);
		//$tema=serialize($idtema);
		//var_dump($idtema);
		//$subtema=serialize($idsubtema);
		//var_dump($idsubtema);
		

		//die('<pre>'.print_r($materia,1).'</pre>');
	    
		$consulta = array(
			//'idconsulta' => $this->input->post('idconsulta'),
			'idcaso' => 	$this->input->post('caso'),
			'idabogado' => 	$this->idabogado,
			'fecha' => 		$this->input->post('fecha'),
			'contenido' => 	$this->input->post('contenido'),
			'materia'=>		$materia,
			'tema'=>		$tema,
			'subtema' => 	$subtema,
			'mtsarray' => 
				json_encode(
					array(
						'm' => $idmateria, 
						't' => $idtema, 
						's' => $idsubtema)),
			'expedientelegal' => $this->input->post('expedientelegal'),
			'respuesta' => 	'',
			);
		$numero_consecutivo=array('num_consecutivo'=>$this->session->consecutivo);
		//$this->db->set('num_consecutivo',$consecutivo);
		$id=10001;
		$this->db->where('idcliente',$id);
		$query=$this->db->update('clientes',$numero_consecutivo);
		$query=$this->db->insert('consultas', $consulta);

		if($query){
			return $this->db->insert_id();
		} else {
			return -1;
		}
		//die('<pre>'.print_r($consulta).'</pre>');
	}

	public function guardar_consulta()
	{
		$consulta = array(
			'idconsulta' => $this->input->post('idconsulta'),
			'idcaso' => 	$this->input->post('idcaso'),
			'idabogado' => 	$this->input->post('idabogado'),
			'fecha' => 		$this->input->post('fecha'),
			'contenido' => 	$this->input->post('contenido'),
			'respuesta' => 	$this->input->post('respuesta'),
			'completada' => $this->input->post('completada'));

		$this->db->where('idconsulta', $consulta->iconsulta);
		$this->db->where('idcaso', $consulta->idcaso);

		return $this->db->update('consultas', $consulta);
	}

	// ivanovitch g

	public function elegir_ejecutor($idconsulta='')
	{
		$consulta_especialidades = json_decode($this->db
			->select('mtsarray')
			->from('consultas')
			->where('idconsulta', $idconsulta)
			->get()->row()->mtsarray)->m;

		//var_dump($consulta_especialidades);

		// $ejecutor= $this->db
		// 	->select('abogado.idabogado')
		// 	->from('abogados')
		// 	->join('consultas', 'abogados.idabogado = idabogadoejecutor', 'right')
		// 	->where_in('especialidad', $consulta_especialidades)
		// 	->order_by('fecha_seguimiento', 'asc')
		// 	->limit(1)->get()->row()->idabogado;


			$this->db->select('abogados.idabogado');
			$this->db->from('abogados');
			$this->db->join('consultas', 'abogados.idabogado = idabogadoejecutor', 'right');
			$this->db->where_in('especialidad', $consulta_especialidades);
			$this->db->where('seguimiento', 1);
			$this->db->where('completada', 1);
			$this->db->order_by('fecha_seguimiento', 'asc');
			$this->db->limit(1);
			$ejecutor_reciente= $this->db->get();

			//die($this->db->last_query());

			$this->db->select('max(idabogado) as idabogado');
			$this->db->from('abogados');
			$this->db->where_in('especialidad', $consulta_especialidades);
			$this->db->where('tipo_usuario', 'ejecutor');
			$ejecutor_mayor = $this->db->get();

			$this->db->select('nombre_completo, idabogado');
			$this->db->from('lista_abogados');
			if(!empty($ejecutor_reciente)){
				if($ejecutor_reciente->row()->idabogado != $ejecutor_mayor->row()->idabogado)
					$this->db->where('idabogado > ', $ejecutor_reciente->row()->idabogado);
			}
			$this->db->where_in('especialidad', $consulta_especialidades);
			$this->db->like('tipo_usuario', 'ejecutor');
			$this->db->order_by('idabogado', 'asc');
			$this->db->limit(1);
			$ejecutor_elegido = $this->db->get();
			//die($this->db->last_query());

			// die('<pre>'.print_r($ejecutor_elegido->row(),1).'</pre>');
			return $ejecutor_elegido->row();
	}

	public function asignar_ejecutor($idconsulta='', $idabogadoejecutor)
	{
		$consulta = array(
			'idabogadoejecutor' => $idabogadoejecutor,
			'seguimiento' => 1,
			'fecha_seguimiento' => date("Y-m-d H:i:s")
			);

		$this->db->where('idconsulta', $idconsulta);
		return $this->db->update('consultas', $consulta);
	}

	public function responder_consulta($idconsulta='', $respuesta='', $datos_respuesta){
		$this->db->insert('respuestas', $datos_respuesta);
		
		$this->db->where('idconsulta', $idconsulta);		
		return $this->db->update('consultas', array('respuesta' => $respuesta)) ;
	}

	public function last_respuesta($idconsulta)
	{
		//echo($idconsulta);
		$query = $this->db
			->where('idconsulta', $idconsulta)
			->order_by('idrespuesta', 'desc')
			->get('respuestas', 1);

		if($query->num_rows() > 0){
			$result = $query->row();
		} else {
			$empty = array('materias' => '','temas' => '','subtemas' => '','op1' => '','pal1' => '','op2' => '','pal2' => '','op3' => '','pal3' => '','op4' => '','pal4' => '','op5' => '','pal5' => '','op6' => '','pal6' => '');
			$result = json_decode(json_encode($empty), FALSE);
		}

		return $result;
	}

	public function guardar_avance($datos)
	{
		return $this->db->insert('seguimiento', $datos);
	}

	public function leer_seguimiento($idconsulta)
	{
		return $this->db->where('idconsulta', $idconsulta)->order_by('timestamp', 'asc')->get('seguimiento')->result();
	}

	public function guardar_caso()
	{
		$caso = array(
			'idcaso' => 	$this->input->post('idcaso'),
			'idcliente' => 	$this->input->post('idcliente'),
			'idabogado' => 	$this->idabogado,
			'expedientelegal' => $this->input->post('expedientelegal'),
			'fechaapertura' => $this->input->post('fechaapertura'),
			'sinopsis' => 	$this->input->post('sinopsis'),
			'pagado' => 	$this->input->post('pagado'),
			'estado' => 	$this->input->post('estado'));

		$this->db->where('idcaso', $caso['idcaso']);
		$this->db->where('idcliente', $caso['idcliente']);

		return $this->db->update('casos', $caso);
	}

	public function terminar_consulta($idconsulta=''){
		$this->db->where('idconsulta', $idconsulta);
		return $this->db->update('consultas', array('completada' => 1));
	}

	public function consultas_de_caso($idcaso = '')
	{
		$this->db->from('consultas');
		$this->db->where('idcaso', $idcaso);
		$this->db->order_by('fecha', 'desc');

		$query = $this->db->get();

		return $query->result();
	}

	public function consulta($idconsulta = ''){
		//$this->db->select('consultas.*, casos.sinopsis, lista_clientes.idcliente, lista_clientes.nombres');
		$this->db->from('consultas');
		$this->db->join('casos', 'consultas.idcaso = casos.idcaso', 'left');
		$this->db->join('lista_clientes', 'casos.idcliente = lista_clientes.idcliente', 'left');
		$this->db->where('consultas.idconsulta', $idconsulta);

		$query = $this->db->get();
		//die($this->db->last_query());

		return $query->result();
	}

	public function caso($idcaso='')
	{

		$this->db->select('lista_clientes.nombres, lista_clientes.apellidop, lista_clientes.apellidom, casos.*');
		$this->db->from('casos');
		$this->db->join('lista_clientes', 'casos.idcliente = lista_clientes.idcliente', 'left');
		
		if($this->session->userdata('consultor_tipo_usuario') != 'administrador')
			$this->db->where('idabogado', $this->idabogado);
		
		$this->db->where('idcaso', $idcaso);

		$this->db->order_by('fechaapertura', 'desc');
		$this->db->order_by('estado', 'desc');

		$query = $this->db->get();

		return $query->result();
	}

}

/* End of file Consultas_model */
/* Location: ./application/models/Consultas_model */